Unit QSL1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QSL1R(var INT :Real; var A :Real; var B :Real; F :Func_F1;
                E :Real);

implementation

procedure QSL1R(var INT :Real; var A :Real; var B :Real; F :Func_F1;
                E :Real);
var
O :Integer;
I,J,K,L,M,C,W,Z2,EPS,H,Z1,P :Real;
NI :Boolean;
AY :Array [0..6] of Real;
BY :Array [0..6] of Real;
KSI :Array [0..6] of Real;
OM :Array [0..2] of Integer;
D :Array [0..2] of Real;
const
SYS051 :Real = 1.192093E-7;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18;
begin
{   DATA  FORTRAN  }
AY[0] := 0.023809;
AY[1] := 0.243809;
AY[2] := 0.023809;
AY[3] := 0.138413;
AY[4] := 0.215872;
AY[5] := 0.215872;
AY[6] := 0.138413;
BY[0] := -0.076190;
BY[1] := 0.243809;
BY[2] := -0.076190;
BY[3] := 0.183701;
BY[4] := -0.229416;
BY[5] := -0.229416;
BY[6] := 0.183701;
KSI[0] := 0.0;
KSI[1] := 0.5;
KSI[2] := 1.0;
KSI[3] := 0.084888;
KSI[4] := 0.265575;
KSI[5] := 0.734424;
KSI[6] := 0.915111;
NI := ( A  > B );
if (  not ( (NI) ) ) 
 then goto _1;
C := A;
A := B;
B := C;
_1:
W := B-A;
if (  not ( (W  = 0.0) ) ) 
 then goto _2;
INT := 0.0;
goto _18;
_2:
Z2 := E/W;
EPS := E;
H := 1.0;
Z1 := EPS/W;
P := 0.0;
INT := 0.0;
OM[0] := 0;
OM[1] := 0;
OM[2] := 0;
_3:
K := P+H;
L := 0.0;
M := 0.0;
for O:=1 to 3 do
 begin
  if ( OM[O-1]  = 0 ) 
   then goto _4;
  I := D[O-1];
  goto _5;
_4:
  J := H*KSI[O-1]+P;
  D[O-1] := F(W*J+A);
  I := D[O-1];
  OM[O-1] := 1;
_5:
  L := L+AY[O-1]*I;
  M := M+BY[O-1]*I;
_6:
 end;
for O:=4 to 7 do
 begin
  J := H*KSI[O-1]+P;
  I := F(W*J+A);
  L := L+AY[O-1]*I;
  M := M+BY[O-1]*I;
_7:
 end;
L := H*L;
M := Abs(H*M);
if ( M-Z1 ) < 0
 then goto _8
 else if ( M-Z1 ) > 0
       then goto _14
       else goto _14;
_8:
P := K;
_9:
INT := INT+L;
I := 1.0-P;
if ( 1.0+I/64.0-1.0 ) < 0
 then goto _17
 else if ( 1.0+I/64.0-1.0 ) > 0
       then goto _10
       else goto _17;
_10:
D[0] := D[2];
OM[1] := 0;
OM[2] := 0;
OM[0] := 1;
if ( M-Z1/IntPower(2.0,7) ) < 0
 then goto _11
 else if ( M-Z1/IntPower(2.0,7) ) > 0
       then goto _12
       else goto _12;
_11:
H := 2.0*H;
_12:
if ( H-I ) < 0
 then goto _3
 else if ( H-I ) > 0
       then goto _13
       else goto _3;
_13:
H := I;
goto _3;
_14:
H := H/2.0;
if ( H-SYS051*P ) < 0
 then goto _15
 else if ( H-SYS051*P ) > 0
       then goto _16
       else goto _15;
_15:
P := P+H*2.0;
H := H*2.0;
goto _9;
_16:
D[2] := D[1];
OM[1] := 0;
goto _3;
_17:
INT := INT*W;
if (  not ( (NI) ) ) 
 then goto _18;
C := B;
B := A;
A := C;
_18:
end;

end.
